local movement_triggers = require("__base__/prototypes/entity/movement-triggers")
local hit_effects = require ("__base__/prototypes/entity/hit-effects")
local sounds = require("__base__/prototypes/entity/sounds")
require ("util")

-- !!This code is really awful, don't use it as a reference!!

data:extend({
	{
		type = "corpse",
		name = "locomotive-remnants-1",
		icon = "__base__/graphics/icons/locomotive.png",
		icon_size = 64, icon_mipmaps = 4,
		flags = {"placeable-neutral", "not-on-map", "placeable-off-grid"},
		subgroup = "train-transport-remnants",
		order = "a-f-a",
		collision_box = {{-1.0, -3.0}, {1.0, 3.0}},
		collision_mask = {"doodad-layer", "not-colliding-with-itself"},
		selection_box = {{-1.0, -3.0}, {1.0, 3.0}},
		tile_width = 2,
		tile_height = 6,
		selectable_in_game = false,
		time_before_removed = 60 * 60 * 15, -- 15 minutes
		final_render_layer = "remnants",
		remove_on_tile_placement = false,
		ground_patch_higher =
		{
			sheets =
			{
				{
					filename = "__base__/graphics/entity/diesel-locomotive/remnants/diesel-locomotive-base-remnants.png",
					width = 230,
					height = 218,
					line_length = 1,
					shift = util.by_pixel(-10, 2),
					variation_count = 8,
	
				},
				{
					filename = "__base__/graphics/entity/diesel-locomotive/remnants/mask/diesel-locomotive-remnants-mask.png",
					width = 196,
					height = 146,
					line_length = 1,
					variation_count = 8,
					shift = util.by_pixel(-10, 2),
					tint = {234,17,0,150},
				}

			}
		}
	},
    



	-- TANK BULLET PROJECTILE
	{
    type = "projectile",
    name = "train-bullet",
    flags = {"not-on-map"},
    collision_box = {{-4, -4}, {4, 4}},
    acceleration = 0,
    direction_only = true,
	piercing_damage = 999999999999,
	rotatable = false,
	action =
	{
		
		type = "direct",
		action_delivery =
		{

			type = "instant",
			target_effects =
			{	

				{
				type = "create-entity",
				entity_name = "big-explosion",
				},
				{
					type = "damage",
					damage = {amount = 5000, type = "impact"}
				},
				{
					type = "damage",
					damage = {amount = 5000, type = "explosion"}
				},
				{
		            type = "create-entity",
					entity_name = "small-scorchmark",
					check_buildability = true
				},		           
				{
					type = "create-entity",
					entity_name = "small-scorchmark",
					check_buildability = true
				}
			}
		}
	},
	
	-- Lazy copy and pasted nuclear explosion
	
	final_action =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =
        {
          {
            type = "set-tile",
            tile_name = "nuclear-ground",
            radius = 12,
            apply_projection = true,
            tile_collision_mask = { "water-tile" }
          },
          {
            type = "destroy-cliffs",
            radius = 9,
            explosion = "explosion"
          },
          {
            type = "create-entity",
            entity_name = "nuke-explosion"
          },
          {
            type = "camera-effect",
            effect = "screen-burn",
            duration = 60,
            ease_in_duration = 5,
            ease_out_duration = 60,
            delay = 0,
            strength = 6,
            full_strength_max_distance = 200,
            max_distance = 800
          },
          {
            type = "play-sound",
            sound = sounds.nuclear_explosion(0.9),
            play_on_target_position = false,
            -- min_distance = 200,
            max_distance = 1000,
            -- volume_modifier = 1,
            audible_distance_modifier = 3
          },
          {
            type = "play-sound",
            sound = sounds.nuclear_explosion_aftershock(0.4),
            play_on_target_position = false,
            -- min_distance = 200,
            max_distance = 1000,
            -- volume_modifier = 1,
            audible_distance_modifier = 3
          },
          {
            type = "damage",
            damage = {amount = 400, type = "explosion"}
          },
          {
            type = "create-entity",
            entity_name = "huge-scorchmark",
            offsets = {{ 0, -0.5 }},
            check_buildability = true
          },
          {
            type = "create-entity",
            entity_name = "locomotive-remnants-1",
			check_buildability = true
          },
          {
            type = "invoke-tile-trigger",
            repeat_count = 1
          },
          {
            type = "destroy-decoratives",
            include_soft_decoratives = true, -- soft decoratives are decoratives with grows_through_rail_path = true
            include_decals = true,
            invoke_decorative_trigger = true,
            decoratives_with_trigger_only = false, -- if true, destroys only decoratives that have trigger_effect set
            radius = 14 -- large radius for demostrative purposes
          },
          {
            type = "create-decorative",
            decorative = "nuclear-ground-patch",
            spawn_min_radius = 11.5,
            spawn_max_radius = 12.5,
            spawn_min = 30,
            spawn_max = 40,
            apply_projection = true,
            spread_evenly = true
          },
          {
            type = "nested-result",
            action =
            {
              type = "area",
              target_entities = false,
              trigger_from_target = false,
              repeat_count = 1000,
              radius = 7,
              action_delivery =
              {
                type = "projectile",
                projectile = "atomic-bomb-ground-zero-projectile",
                starting_speed = 0.6 * 0.8,
                starting_speed_deviation = nuke_shockwave_starting_speed_deviation
              }
            }
          },
          {
            type = "nested-result",
            action =
            {
              type = "area",
              target_entities = false,
              trigger_from_target = true,
              repeat_count = 1000,
              radius = 35,
              action_delivery =
              {
                type = "projectile",
                projectile = "atomic-bomb-wave",
                starting_speed = 0.5 * 0.7,
                starting_speed_deviation = nuke_shockwave_starting_speed_deviation
              }
            }
          },
          {
            type = "nested-result",
            action =
            {
              type = "area",
              show_in_tooltip = false,
              target_entities = false,
              trigger_from_target = true,
              repeat_count = 1000,
              radius = 26,
              action_delivery =
              {
                type = "projectile",
                projectile = "atomic-bomb-wave-spawns-cluster-nuke-explosion",
                starting_speed = 0.5 * 0.7,
                starting_speed_deviation = nuke_shockwave_starting_speed_deviation
              }
            }
          },
          {
            type = "nested-result",
            action =
            {
              type = "area",
              show_in_tooltip = false,
              target_entities = false,
              trigger_from_target = true,
              repeat_count = 700,
              radius = 4, 
              action_delivery =
              {
                type = "projectile",
                projectile = "atomic-bomb-wave-spawns-fire-smoke-explosion",
                starting_speed = 0.5 * 0.65,
                starting_speed_deviation = nuke_shockwave_starting_speed_deviation
              }
            }
          },
          {
            type = "nested-result",
            action =
            {
              type = "area",
              show_in_tooltip = false,
              target_entities = false,
              trigger_from_target = true,
              repeat_count = 1000,
              radius = 8, 
              action_delivery =
              {
                type = "projectile",
                projectile = "atomic-bomb-wave-spawns-nuke-shockwave-explosion",
                starting_speed = 0.5 * 0.65,
                starting_speed_deviation = nuke_shockwave_starting_speed_deviation
              }
            }
          },
          {
            type = "nested-result",
            action =
            {
              type = "area",
              show_in_tooltip = false,
              target_entities = false,
              trigger_from_target = true,
              repeat_count = 300,
              radius = 26,
              action_delivery =
              {
                type = "projectile",
                projectile = "atomic-bomb-wave-spawns-nuclear-smoke",
                starting_speed = 0.5 * 0.65,
                starting_speed_deviation = nuke_shockwave_starting_speed_deviation
              }
            }
          },
          {
            type = "nested-result",
            action =
            {
              type = "area",
              show_in_tooltip = false,
              target_entities = false,
              trigger_from_target = true,
              repeat_count = 10,
              radius = 8,
              action_delivery =
              {
                type = "instant",
                target_effects =
                {
                  {
                    type = "create-entity",
                    entity_name = "nuclear-smouldering-smoke-source",
                    tile_collision_mask = { "water-tile" }
                  }
                }
              }
            }
          },      
          
        }
      }
	  
    },
	
					

    animation =
	{
      layers =
      {
        {
          width = 238,
          height = 230,
          filename = "__traingun__/graphics/train/base.png",
		  line_length = 33,
          shift = {0.0, -0.5},
		  animation_speed = 7,  
		  frame_count = 255
		},
        {
          flags = { "mask" },
          width = 236,
          height = 228,
          filename = "__traingun__/graphics/train/overlay.png",
          line_length = 33,
          shift = {0.0, -0.5},
		  tint = {234,17,0,150},
          --apply_runtime_tint = true,	
		  animation_speed = 7,
		  frame_count = 255,
	 	},
        {
          width = 253,
          height = 212,
		  draw_as_shadow = true,
          flags = { "shadow" },
          filename = "__traingun__/graphics/train/shadow.png",
          shift = {1, 0.3},
		  line_length = 30,
		  animation_speed = 7,  
		  frame_count = 255,
		}
	  }
	}
  }
})